From 81c088b09968df9e82c2fc9d4ffc9177670a7c48 Mon Sep 17 00:00:00 2001
From: Pan Nengyuan <pannengyuan@huawei.com>
Date: Mon, 30 Mar 2020 11:55:07 +0800
Subject: [PATCH 08/77] nodedev: add smmu support on aarch64

check smmu is enable or not on aarch64.

Signed-off-by: Pan Nengyuan <pannengyuan@huawei.com>
---
 .../src/virsh_cmd/nodedev/virsh_nodedev_event.py  | 15 ++++++++++-----
 1 file changed, 10 insertions(+), 5 deletions(-)

diff --git a/libvirt/tests/src/virsh_cmd/nodedev/virsh_nodedev_event.py b/libvirt/tests/src/virsh_cmd/nodedev/virsh_nodedev_event.py
index d5cc2067..cbe8f328 100644
--- a/libvirt/tests/src/virsh_cmd/nodedev/virsh_nodedev_event.py
+++ b/libvirt/tests/src/virsh_cmd/nodedev/virsh_nodedev_event.py
@@ -1,6 +1,7 @@
 import time
 import logging
 import aexpect
+import platform
 from avocado.utils import process
 
 from virttest import virsh
@@ -116,21 +117,25 @@ def run(test, params, env):
         net_device_address = nodedev_xml.NodedevXML.new_from_dumpxml(net_device_name).parent
         return net_device_address
 
-    def check_kernel_option():
+    def check_device_mmu_option():
         """
-        Check the kernel option if the kernel cmdline include  "iommu=on" option
+        For x86, check the kernel option if the kernel cmdline include  "iommu=on" option.
+        For arm, check the devices if smmu is enable or not.
         """
         check_cmd = "egrep '(intel|amd)_iommu=on' /proc/cmdline"
+        if 'aarch' in platform.machine():
+            check_cmd = "ls /sys/devices/ | grep smmu"
+
         try:
             check_result = process.run(check_cmd, shell=True)
         except Exception:
             test.cancel("Operation not supported: neither VFIO nor KVM device assignment"
                         "is currently supported on this system")
         else:
-            logging.debug('IOMMU is enabled')
+            logging.debug('IOMMU/SMMU is enabled')
 
-    # Check kernel iommu option
-    check_kernel_option()
+    # Check iommu/smmu option
+    check_device_mmu_option()
 
     # Init variables
     nodedev_event_list = params.get("nodedev_event_list")
-- 
2.23.0

